﻿'use strict';

function ChatItem(userProviderKey, currentDate, chatHub, userSessions) {
    var ci = this;
    ci.userProviderKey = userProviderKey;
    ci.currentDate = currentDate;
    ci.chatHub = chatHub;
    if (userSessions)
        ci.userSessions = userSessions;

    ci.preInit();
    
    ci.viewModel = ko.observable(null);
    ci.session = ko.pureComputed(ci.getSession, ci);
    ci.myUserSession = ko.pureComputed(ci.getMyUserSession, ci);
}

ChatItem.prototype.preInit = function () {
    var ci = this;
    if (typeof ci.userSessions !== "undefined") {
        ci.sessionId = ci.userSessions[0].Session.SessionId;
    }
    else throw "Argument exception.";
};

ChatItem.prototype.init = function () {
    var ci = this;
    return new Promise(function (resolve, reject) {
        if (typeof ci.userSessions !== "undefined") {
            ci.createAndInitChatSessionViewModel(ci.userSessions).then(function () {
                resolve();
            }).catch(function (error) {
                reject(error);
            });
        }
        else
            reject();

        delete ci.userSessions;
    });
};

ChatItem.prototype.getSession = function () {
    var ci = this;
    var viewModel = ci.viewModel();
    return viewModel ? viewModel.session() : null;
};

ChatItem.prototype.getMyUserSession = function () {
    var ci = this;
    var viewModel = ci.viewModel();
    return viewModel ? viewModel.myUserSession() : null;
};