﻿$(document).ready(function () {
    $("body").on("change", "#ddlRoot", function () { treeChange(); });
    $(".visibilitySettings").hide();
    $(".visibilitySettingsRoot").hide();

    $("body").on("change", "#Settings", function () { inheritFromParentChange(); });

    $("body").on("change", "#RestrictVisibility, #OnlyOperators, #Everyone", function () { visbleForEveryOne(); });

    $("#selectedCategory").on("click", ".kb-flag", function () {
        OnAjaxBegin(Localization_KnowledgeBase_LoadingArticles);
        $.post(
        RQ_URL + '/KnowledgeBase/SelectedFlag',
        {
            id: $(this).attr("data-id"),
        },
        function (data) {
            $("#selectedCategory").html(data);
        },
        "html"
        )
        .fail(function (error) { alert(error.responseText); })
        .done(function () { })
        .always(function () { OnAjaxComplete(); });
    })

    $("#dialog-confirm-category").dialog({
        autoOpen: false,
        modal: true,
        resizable: false,
        width: 350,
        buttons: [{
            text: Localization_Yes,
            click: function () {
                $.ajax({
                    url: RQ_URL + '/KnowledgeBaseCategory/DeleteCategory',
                    type: "POST",
                    dataType: "json",
                    contentType: "application/json; charset=utf-8",
                    data: JSON.stringify({ id: deleteCategoryId }),
                    success: function (g) {
                        realodTree();
                    },
                });
                $("#dialog-confirm-category").dialog("close");
            },
        },
    {
        text: Localization_No,
        click: function () {
            $("#dialog-confirm-category").dialog("close");
        }
    }
        ]
    });

    $("#dialog-confirm").dialog({
        autoOpen: false,
        modal: true,
        resizable: false
    });

    $("#dialog-new-category").dialog({
        autoOpen: false,
        modal: true,
        resizable: false,
        width: 800,
        buttons: [{
            text: Localization_Save,
            click: function () {
                var name = $("#Name").val();
                if (name != "" && name != undefined && name != null) {
                    var description = $("#Description").val();
                    $(".vendorsValidation").hide();
                    $.ajax({
                        url: RQ_URL + '/KnowledgeBaseCategory/NewOrUpdateCategory',
                        type: "POST",
                        dataType: "json",
                        contentType: "application/json; charset=utf-8",
                        data: JSON.stringify({
                            model:
                            {
                                ParentId: $("#ddlRoot").val(),
                                Name: name,
                                Id: $("#CategoryId").val(),
                                Description: description,
                                InheritsFromParentDocument: $("#Settings").prop("checked"),
                                VisibilityType: $("[name='VisibilityType']:checked").val(),
                                OperatorGroups: $("#OperatorGroups").val(),
                                InternalGroups: $("#InternalGroups").val(),
                                Customers: $("#Customers").val(),
                                Users: $("#Users").val(),
                            }
                        }),
                        success: function (g) {
                            HideWarning();
                            if (g != "Ok") {
                                ShowWarning(g);
                            }
                            realodTree();
                        },
                        error: function (error) { alert(error.responseText); },
                    });
                    $(this).dialog("close");
                }
                else {
                    $(".vendorsValidation").show();
                }
            }},{
            text: Localization_Close,
            click: function () {
                $(this).dialog("close");
            }
        }]
    });

    $(".vendorsValidation").hide();

    $(".deleteLink").click(function (e) {
        e.preventDefault();
        var targetUrl = $(this).attr("href");

        $("#dialog-confirm").dialog({
            buttons: [
                {
                    text: Localization_Yes,
                    click: function () {
                        window.location.href = targetUrl;
                    }
                },
                {
                    text: Localization_No,
                    click: function () {
                        $(this).dialog("close");
                    }
                }
            ]
        });

        $("#dialog-confirm").dialog("open");
    });



    //var formKnowledgeBaseSearchFor = $('#formKnowledgeBaseSearchFor');
    var tbSearchKB = $('#search-input-KB');

    //formKnowledgeBaseSearchFor.submit(function () {
    //    return tbSearchKB.val().trim() != '';
    //});

    var timer;
    tbSearchKB.keyup(function () {
        clearTimeout(timer);
        var ms = 500; // milliseconds
        var val = this.value;
        timer = setTimeout(function () {
            GetAutocompleteKB();
        }, ms);
    });

    tbSearchKB.blur(function () {
        setTimeout(function () {
            HideResultKB();
        }, 250);
    });
    
    $("#Users").select2({
        minimumInputLength: 2,
        multiple: true,
        width: '100%',
        ajax: {
            url: RQ_URL + '/Account/UsersForSelect2Ajax',
            type: "POST",
            dataType: 'json',
            delay: 250,
            data: function (params) {
                return {
                    pageSize: 10,
                    pageNum: params.page || 1,
                    term: params.term,
                };
            },
            processResults: function (data, params) {
                params.page = data.PageNum;

                return {
                    results: data.Results,
                    pagination: {
                        more: (data.PageNum * data.PageSize) < data.Total
                    }
                };
            },
            cache: true,
        },
        escapeMarkup: function (markup) { return markup; },
        templateResult: formatUsersForSelect2AjaxData,
        templateSelection: formatUsersForSelect2AjaxElement,
    });

    //expandFirstLevel();
});

function addCategory() {
    $("#dialog-new-category").html("<div class='loading-32'></div>");
    $("#dialog-new-category").dialog('option', 'title', Localization_NewCategory);
    $("#dialog-new-category").dialog("open");
    $("#dialog-new-category").load(RQ_URL + "/KnowledgeBaseCategory/NewOrEditCategory", function () {
        $("#ddlRoot").trigger("change");
        inheritFromParentChange();
        $("#dialog-new-category").dialog("close");
        $("#dialog-new-category").dialog("open");
    });
}

function inheritFromParentChange() {
    if ($("#Settings").prop("checked")) {
        $(".visibilitySettings").hide();
        $(".visibilitySettingsRoot").hide();
        if ($("#ddlRoot").val() == -1) {
            $(".visibilitySettingsRoot").show();
            visbleForEveryOne();
        }
    }
    else {
        $(".visibilitySettings").show();
        visbleForEveryOne();
    }
}

function visbleForEveryOne() {
    if ($("#RestrictVisibility").prop("checked")) {
        $(".visibilitySettings").show();
        $(".visibilitySettingsRoot").show();
    }
    else {
        $(".visibilitySettings").hide();
        $(".visibilitySettingsRoot").show();
    }
}

function treeChange() {
    inheritFromParentChange();
    if ($("#ddlRoot").val() == -1) {
        $("#inheritFromParetnTr").hide();
    }
    else {
        $("#inheritFromParetnTr").show();
    }
}

function expandFirstLevel() {
    $.each($("#treeMenu").children(), function (i, val) {

        $(val).children(":nth-child(1)").children(":nth-child(1)").removeClass("fa-angle-right");
        $(val).children(":nth-child(1)").children(":nth-child(1)").addClass("fa-angle-down");
        $(val).children(":nth-child(3)").css("display", "block");
        $(val).children(":nth-child(2)").css("display", "block");
    });
}

var selectedArticleId = null;

function selectArticle(id) {
    selectedArticleId = id;
    $("#treeMenu").find(".btn-default").css("border-color", "#F5F6F7");
    $("#treeMenu").find(".btn-default").css("background-color", "#F5F6F7");
    var parent = $("#articleItem" + id).parent().parent().parent();
    parent.children(":nth-child(1)").children(":nth-child(1)").removeClass("fa-angle-right");
    parent.children(":nth-child(1)").children(":nth-child(1)").addClass("fa-angle-down");
    parent.children(":nth-child(3)").css("display", "block");
    parent.children(":nth-child(2)").css("display", "block");

    $(".selected-knowledge").removeClass("selected-knowledge");
    $("#articleItem" + id + " .knowldge-menu-name").parent().parent().addClass("selected-knowledge");
    showArticle(id, null);
}

function selectArticle(id, categoryId) {
    selectedArticleId = id;
    selectedCategoryId = categoryId;
    $("#treeMenu").find(".btn-default").css("border-color", "#F5F6F7");
    $("#treeMenu").find(".btn-default").css("background-color", "#F5F6F7");
    var parent = $("#knowledgeItem" + categoryId).closest("#articleItem" + id).closest(".knowledge-menu-div");
    parent.children(":nth-child(1)").children(":nth-child(1)").removeClass("fa-angle-right");
    parent.children(":nth-child(1)").children(":nth-child(1)").addClass("fa-angle-down");
    parent.children(":nth-child(3)").css("display", "block");
    parent.children(":nth-child(2)").css("display", "block");

    $(".selected-knowledge").removeClass("selected-knowledge");
    var articles = $("#knowledgeItem" + categoryId).parent().find("#articleItem" + id + " .knowldge-menu-name");
    for (var i = 0; i < articles.length; i++) {
        if ($($(articles[i]).parent().parent().parent().parent().parent().children()[0]).prop('id') == "knowledgeItem" + categoryId) {
            $(articles[i]).parent().parent().addClass("selected-knowledge");
        }
    }
    showArticle(id, categoryId);
}

function showSelectedCategory(id, dontLoadData) {
    $(".selected-div-alphabet").removeClass("selected-div-alphabet");
    $("#alphabetItem" + id).addClass("selected-div-alphabet");
    $("#alphabetMenu").find(".btn-default").css("border-color", "#F5F6F7");
    $("#alphabetMenu").find(".btn-default").css("background-color", "#F5F6F7");
    $("#alphabetItem" + id).find(".btn-default").css("border-color", "#e8e8e8");
    $("#alphabetItem" + id).find(".btn-default").css("background-color", "#e8e8e8");
    $("#treeMenu").find(".btn-default").css("border-color", "#F5F6F7");
    $("#treeMenu").find(".btn-default").css("background-color", "#F5F6F7");
    $("#knowledgeItem" + id).find(".btn-default").css("border-color", "#e8e8e8");
    $("#knowledgeItem" + id).find(".btn-default").css("background-color", "#e8e8e8");
    $(".selected-knowledge").removeClass("selected-knowledge");
    $("#knowledgeItem" + id + " .knowldge-menu-name").parent().parent().addClass("selected-knowledge");
    displayOrHideNodes(id);
    setTreeVisible(id);
    if (!dontLoadData) {
        showCategory(id);
    }
}

function showSelectedArticle(id, categoryId) {
    //var parent = $("#articleItem" + id).parent().parent().parent();
    //parent.children(":nth-child(3)").css("display", "block");
    //parent.children(":nth-child(2)").css("display", "block");
    selectArticle(id, categoryId);
}

function setTreeVisible(id) {
    var parent = $("#knowledgeItem" + id + " .knowldge-menu-name").parent();
    if (parent.length > 0) {
        if (parent.css("display") == "none") {
            parent.css("display", "block");
            $("#knowledgeItem" + id).find(".btn-default").css("border-color", "#e8e8e8");
            $("#knowledgeItem" + id).find(".btn-default").css("background-color", "#e8e8e8");
            parent.parent().children(":nth-child(3)").css("display", "block");
            parent.parent().children(":nth-child(2)").css("display", "block");
        }

        while (!(parent.attr("id") == "treeMenu")) {
            parent = parent.parent();
            if (parent.css("display") == "none") {
                parent.css("display", "block");
                parent.parent().children(":nth-child(3)").css("display", "block");
                parent.parent().children(":nth-child(2)").css("display", "block");
            }
        }
    }
}

var ids = new Array();

function displayOrHideNodes(id) {
    if ($("#arrow" + id).hasClass("fa-angle-right")) {
        if (ids.indexOf(id) == -1) {
            ids.push(id);
        }
        $("#arrow" + id).removeClass("fa-angle-right");
        $("#arrow" + id).addClass("fa-angle-down");
        $("#knowledgeItem" + id).closest(".knowledge-menu-div").children(":nth-child(2)").css("display", "block");
        $("#knowledgeItem" + id).closest(".knowledge-menu-div").children(":nth-child(3)").css("display", "block");
    }
    else {
        var index = ids.indexOf(id);
        if (index > -1) {
            ids.splice(index, 1);
        }
        $("#arrow" + id).removeClass("fa-angle-down");
        $("#arrow" + id).addClass("fa-angle-right");
        $("#knowledgeItem" + id).closest(".knowledge-menu-div").children(":nth-child(2)").css("display", "none");
        $("#knowledgeItem" + id).closest(".knowledge-menu-div").children(":nth-child(3)").css("display", "none");
    }
}

function SelectTreeOrAlphabet(type) {
    if (type == 1) {
        $(".tree-knowledge").removeClass("selected-type-knowledge");
        $(".alphabet-knowledge").removeClass("selected-type-knowledge");
        $(".tree-knowledge").addClass("selected-type-knowledge");
        $("#treeMenu").css("display", "");
        $("#alphabetMenu").css("display", "none");
    }
    else {
        $(".tree-knowledge").removeClass("selected-type-knowledge");
        $(".alphabet-knowledge").removeClass("selected-type-knowledge");
        $(".alphabet-knowledge").addClass("selected-type-knowledge");
        $("#treeMenu").css("display", "none");
        $("#alphabetMenu").css("display", "");
    }
}

function alphabetSetVisible(id) {
    $("#alphabetMenu").find(".btn-default").css("border-color", "#F5F6F7");
    $("#alphabetMenu").find(".btn-default").css("background-color", "#F5F6F7");
    $(".selected-div-alphabet").removeClass("selected-div-alphabet");
    $("#alphabetItem" + id).find(".btn-default").css("border-color", "#e8e8e8");
    $("#alphabetItem" + id).find(".btn-default").css("background-color", "#e8e8e8");
    $("#alphabetItem" + id).addClass("selected-div-alphabet");
}

function alphabetSelect(id) {
    selectedCategoryId = id;
    alphabetSetVisible(id);
    setTreeVisible(id);
    categorySetVisible(id);
    $("#treeMenu").css("display", "none");
    showCategory(id);
}

function showArticle(id, categoryId) {
    OnAjaxBegin(Localization_KnowledgeBase_LoadingArticle);
    $.post(
    RQ_URL + '/KnowledgeBase/SelectedArticle',
    {
        id: id,
        categoryId: categoryId,
    },
    function (data) {
        //alert(data);
        $("#selectedCategory").html(data);
    },
    "html"
    )
    .fail(function (error) { alert(error.responseText); })
    .done(function () { })
    .always(function () { OnAjaxComplete(); });
}

function showCategory(id) {
    OnAjaxBegin(Localization_KnowledgeBase_LoadingCategory);
    $.post(
    RQ_URL + '/KnowledgeBase/SelectedCategory',
    {
        id: id,
    },
    function (data) {
        //alert(data);
        $("#selectedCategory").html(data);
    },
    "html"
    )
    .fail(function (error) { alert(error.responseText); })
    .done(function () { })
    .always(function () { OnAjaxComplete(); });
}

var selectedCategoryId = null;



function selectedCategoryTree(id) {
    selectedCategoryId = id;
    selectedArticleId = null;
    categorySetVisible(id);
    setTreeVisible(id);
    alphabetSetVisible(id);
    showCategory(id);
}


function selectedCategory(id) {
    selectedCategoryId = id;
    selectedArticleId = null;
    categorySetVisible(id);
    displayOrHideNodes(id);
    alphabetSetVisible(id);
    showCategory(id);
}

function selectedCategoryButDoNotHideChildren(id) {
    selectedCategoryId = id;
    selectedArticleId = null;
    categorySetVisible(id);
    alphabetSetVisible(id);
    showCategory(id);
}

function categorySetVisible(id) {
    $(".selected-knowledge").removeClass("selected-knowledge");
    $("#knowledgeItem" + id + " .knowldge-menu-name").parent().parent().addClass("selected-knowledge");
    $("#treeMenu").find(".btn-default").css("border-color", "#F5F6F7");
    $("#treeMenu").find(".btn-default").css("background-color", "#F5F6F7");
    $("#knowledgeItem" + id).find(".btn-default").css("border-color", "#e8e8e8");
    $("#knowledgeItem" + id).find(".btn-default").css("background-color", "#e8e8e8");
}

function GetAutocompleteKB() {

    var div = $("#divAutocompleteKB");
    div.empty();

    var q = $("#search-input-KB").val();
    if (q.length > 0) {
        // creating list
        var ul = $(document.createElement('ul')).attr("id", "autocompleteKB_ul").appendTo(div);

        $.post(
        RQ_URL + '/KnowledgeBase/SearchForCategoriesAutocomplete',
        { searchText: q },
        function (data) {
            if ($(data).length != 0) {
                $("#autocompleteKB_ul li.category-autocomplete").remove();

                // append Categories
                $(document.createElement('li')).attr("class", "main category-autocomplete").text(Localization_Categories).appendTo(ul);

                $(data).each(function () {
                    var li = $(document.createElement('li')).attr("class", "category-autocomplete");
                    var a = $(document.createElement('a')).attr("href", this.Url).text(this.Name).appendTo(li);

                    li.appendTo($("#autocompleteKB_ul"));
                });
            }
        },
        "json"
        )
        .fail(function (error) { alert(error.responseText); })
        .done(function () { LoadArticles(q); });
    }
    else {
        div.hide();
    }
}

function LoadArticles(q) {
    // load ticket messages 

    var div = $("#divAutocompleteKB");
    var ul = $("#autocompleteKB_ul");

    $.post(
    RQ_URL + '/KnowledgeBase/SearchForArticlesAutocomplete',
    { searchText: q },
    function (data) {
        if ($(data).length != 0) {
            $("#autocompleteKB_ul li.ticketMessage-autocomplete").remove();

            // append Articles title
            $(document.createElement('li')).attr("class", "main ticketMessage-autocomplete").text(Localization_Articles).appendTo(ul);

            $(data).each(function () {
                if (this.Title === "showmore") {
                    var li = $(document.createElement('li')).attr("class", "main");
                    var a_link = $(document.createElement('a')).attr("href", "javascript:void(0);").text(Localization_ShowMore + " (" + this.Url + ")");

                    a_link.click(function () {
                        $('#formKnowledgeBaseSearchFor').submit();
                    });

                    a_link.appendTo(li);
                    li.appendTo($("#divAutocompleteKB"));
                }
                else {
                    var li = $(document.createElement('li')).attr("class", "ticketMessage-autocomplete");
                    var a = $(document.createElement('a')).attr("href", this.Url).text(this.Title).attr("title", this.Title).appendTo(li);
                    var br = $(document.createElement('br')).appendTo(li);
                    var detail = this.Introduction;
                    var span = $(document.createElement('span')).attr("title", detail).text(detail).appendTo(li);
                    li.appendTo($("#autocompleteKB_ul"));
                }
            });
        }
    },
    "json"
    )
    .fail(function (error) { alert(error.responseText); })
    .done(function () {
        if ($("#autocompleteKB_ul > li").length > 0) {
            div.slideDown();
        }
        else {
            div.slideDown();
            $(document.createElement('li')).attr("class", "nothing").text("Nenalezeno").appendTo(ul);
        }
    });
}

function HideResultKB() {
    $("#divAutocompleteKB").slideUp();
}

function newCategory(id) {
    $("#dialog-new-category").html("<div class='loading-32'></div>");
    $("#dialog-new-category").dialog('option', 'title', Localization_NewCategory);
    $("#dialog-new-category").dialog("open");
    $("#dialog-new-category").load(RQ_URL + "/KnowledgeBaseCategory/NewOrEditCategory?rootId=" + id, function () {
        $("#ddlRoot").trigger("change");
        inheritFromParentChange();
        $("#dialog-new-category").dialog("close");
        $("#dialog-new-category").dialog("open");
    });
}

function editTree(id) {
    $("#dialog-new-category").html("<div class='loading-32'></div>");
    $("#dialog-new-category").dialog('option', 'title', Localization_NewCategory);
    $("#dialog-new-category").dialog("open");
    $("#dialog-new-category").load(RQ_URL + "/KnowledgeBaseCategory/NewOrEditCategory/" + id, function () {
        $("#ddlRoot").trigger("change");
        inheritFromParentChange();
        $("#dialog-new-category").dialog("close");
        $("#dialog-new-category").dialog("open");
    });
}

var deleteCategoryId = null;

function deleteTree(id) {
    deleteCategoryId = id;
    $("#dialog-confirm-category").dialog("open");
}

function realodTree() {
    OnAjaxBegin(Localization_KnowledgeBase_LoadingTree);
    $("#knowledge-menu").load(RQ_URL + "/KnowledgeBase/ReloadTreePartial", function () {
        $.each(ids, function (index, value) {
            if (selectedCategoryId != value) {
                displayOrHideNodes(value);
            }
        });
        if(selectedCategoryId != null)
        {
            showSelectedCategory(selectedCategoryId);
        }
        if (selectedArticleId != null)
        {
            showSelectedArticle(selectedArticleId, selectedCategoryId);
        }
        //expandFirstLevel();
        OnAjaxComplete();
    });
}